class ItemPedido:
	def inicia(self, codigo, nome, preco):
		self.codigo = codigo
		self.nome = nome
		self.preco = preco
		self.quantidade = 0
	def imprime(self):
		print str(self.codigo).rjust(2), self.nome.rjust(2), self.preco.rjust(2)		


def leituraItensPedidos(nomeArquivo):
	arquivo = open(nomeArquivo)
	listaItemPedidos = {}
	listaStringItemPedidos = arquivo.readlines()
	listaStringItemPedidos = listaStringItemPedidos[1:]
	for i in listaStringItemPedidos:
		item = ItemPedido()
		aux = i.split(';')
		item.inicia(int(aux[0]),aux[1],aux[2])
		listaItemPedidos[item.codigo] = item
	arquivo.close()
	return listaItemPedidos

class Entregador:
	def inicia(self, nome, placa):
		self.nome = nome
		self.placa = placa
	def imprime(self):
		print self.nome
		print self.placa

def leituraEntregadores(nomeArquivo):
	arquivo = open(nomeArquivo)
	listaEntregadores = []
	listaStringEntregadores = arquivo.readlines()
	listaStringEntregadores = listaStringEntregadores[1:]
	for i in listaStringEntregadores:
		entregador = Entregador()
		aux = i.split(';')
		entregador.inicia(aux[0],aux[1])
		listaEntregadores.append(entregador)
	arquivo.close()
	return listaEntregadores

class Cliente:
	def cadastra(self, telefone, nome, endereco, ptoReferencia):
		self.telefone = telefone
		self.nome = nome
		self.endereco = endereco
		self.ptoReferencia = ptoReferencia
	def imprime(self):
		print self.telefone
		print self.nome
		print self.endereco
		print self.ptoReferencia

def atendimento(cardapio, entregadores):
	telefone = raw_input("Telefone (0 para sair):\n")
	clientes = {}
	listaCardapio = []

	while (telefone != '0'):

		if(not(telefone in clientes)):
			cliente = Cliente()
			nome = raw_input("Cliente nao cadastrado. Novo cadastro:\n\tNome:  ")
			endereco = raw_input("\tEndereco:  ")
			ptoReferencia = raw_input("\tPonto de Referencia:  ")
			cliente.cadastra(telefone, nome, endereco, ptoReferencia)
			clientes[telefone] = cliente
			print("Cadastra cliente, associando-o ao telefone")

		opcao = 'a'
		
		while((opcao != 'C') and (opcao != 'c')):
			opcao = raw_input("Cliente cadastrado: %s\n[C]onfirma ou [R]ecadastra? "%clientes[telefone].nome)

			if(opcao == 'r' or opcao == 'R'):
				nome = raw_input("Recadastrando cliente (telefone %s):\n\tNome:  "%telefone)
				endereco = raw_input("\tEndereco:  ")
				ptoReferencia = raw_input("\tPonto de Referencia:  ")
				cliente.cadastra(telefone, nome, endereco, ptoReferencia)
				clientes[telefone] = cliente
				print("Cadastra cliente, associando-o ao telefone")

		codigo = 'a'
		pedido = []
		precoPedido = 0
		while(codigo != '0'):
			codigo = raw_input("Adicionar item numero (? para cardapio, 0 para finalizar): ")
			if (codigo == '?'): #Precisa dar um jeito de imprimir a lista ordenada
				for i in cardapio:
					cardapio[i].imprime()
			elif(codigo != '0'):
				if(int(codigo) in cardapio):
					quantidade = raw_input("Adicionando %s ao pedido. Quantidade: "%cardapio[int(codigo)].nome)
					pedido.append((int(codigo), int(quantidade)))
					precoPedido += int(quantidade)*float(cardapio[int(codigo)].preco.replace(',','.'))
				else:
					print("Nao ha item com codigo %s no cardapio."%codigo)

		resposta = raw_input("Total: R$ %f. Confirma? "%precoPedido)
		if(resposta == 's' or resposta == 'S'):
			for i in pedido:
				cardapio[i[0]].quantidade += i[1]


		telefone = raw_input("Telefone (0 para sair):\n")

def relatorio(cardapio):
	arquivo = open("itensVendidos.csv", 'w')
	arquivo.write("Item;Qtd. vendida;Pico de procura\n")
	for i in cardapio:
		msg = str(cardapio[i].codigo) + cardapio[i].nome + ';' + str(cardapio[i].quantidade) + ";"
		if(cardapio[i].quantidade < 5):
			msg += "Nao\n"
		else:
			msg += "Sim\n"
		arquivo.write(msg)
	arquivo.close()

cardapio = leituraItensPedidos("cardapio.csv")
entregadores = leituraEntregadores("entregadores.csv")
atendimento(cardapio, entregadores)
relatorio(cardapio)